package com.talkweb.recovery.service.impl;

package ..deTemp.1747366565230;

import cn.com.taiji.sdk.comm.LwClientHelper;
import cn.com.taiji.sdk.model.comm.protocol.ncdts.query.ExitQueryResultResponse;
import cn.com.taiji.sdk.model.comm.protocol.ncdts.query.ExitTransQueryRequest;
import cn.com.taiji.sdk.model.comm.protocol.tacdts.query.LastGantryQueryRequest;
import cn.com.taiji.sdk.model.comm.protocol.tacdts.query.LastGantryQueryResponse;
import cn.hutool.core.codec.Base64;
import cn.hutool.core.util.NumberUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.talkweb.pangu.base.common.result.AResultCode;
import com.talkweb.pangu.base.common.result.ResultMap;
import com.talkweb.pangu.base.common.util.StringUtil;
import com.talkweb.recovery.dao.TPasstuCheckMapper;
import com.talkweb.recovery.dao.TPasstuTransactionCheckMapper;
import com.talkweb.recovery.dao.TRecoveryResultMapper;
import com.talkweb.recovery.dataSource.annotation.TargetDataSource;
import com.talkweb.recovery.pojo.BSIdBean;
import com.talkweb.recovery.pojo.CenterViewBean;
import com.talkweb.recovery.pojo.HolidaysDto;
import com.talkweb.recovery.pojo.TPasstuCheckBean;
import com.talkweb.recovery.pojo.TPasstuTransactionCheckBean;
import com.talkweb.recovery.pojo.TRecoveryJobBean;
import com.talkweb.recovery.pojo.TRecoveryResultBean;
import com.talkweb.recovery.pojo.TprcNecuBean;
import com.talkweb.recovery.pojo.TprcNrscuBean;
import com.talkweb.recovery.remoteapi.IBasicDataServerDataApi;
import com.talkweb.recovery.remoteapi.IDataServiceDataApi;
import com.talkweb.recovery.service.ETCRecoveryDataService;
import com.talkweb.recovery.service.ReconciliationService;
import com.talkweb.recovery.utils.CacheUtil;
import com.zgglyun.common.model.comm.protocol.AbstractTypeRequest;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Resource;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.lang3.time.DateUtils;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class ETCRecoveryDataServiceImpl implements ETCRecoveryDataService {
  private static final Logger log = LoggerFactory.getLogger(com.talkweb.recovery.service.impl.ETCRecoveryDataServiceImpl.class);
  
  @Resource
  private IDataServiceDataApi dataServiceDataApi;
  
  @Resource
  private IBasicDataServerDataApi basicDataServiceDataApi;
  
  @Resource
  private TPasstuCheckMapper tPasstuCheckMapper;
  
  @Resource
  private TPasstuTransactionCheckMapper tPasstuTransactionCheckMapper;
  
  @Autowired
  private ReconciliationService reconciliationService;
  
  @Autowired
  private ETCRecoveryDataService etcRecoveryDataService;
  
  @Resource
  private TRecoveryResultMapper trecoveryResultMapper;
  
  public List<HolidaysDto> getCacheHolidayData() {
    try {
      SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
      Date nowDate = new Date();
      Calendar calendar = Calendar.getInstance();
      calendar.setTime(nowDate);
      calendar.add(5, 0);
      String currentDate = sdf.format(calendar.getTime());
      if (StringUtil.isNull(CacheUtil.getCacheDate()) || StringUtil.isNull(CacheUtil.getCacheHolidayData())) {
        ResultMap<AResultCode, List<HolidaysDto>> oroHolidayParamlList = this.basicDataServiceDataApi.getOroHolidayData();
        CacheUtil.putCacheDate(currentDate);
        CacheUtil.putCacheHolidayData((List)oroHolidayParamlList.getResult());
      } else {
        String cache = CacheUtil.getCacheDate();
        if (!cache.equals(currentDate)) {
          ResultMap<AResultCode, List<HolidaysDto>> oroHolidayParamlList = this.basicDataServiceDataApi.getOroHolidayData();
          CacheUtil.putCacheDate(currentDate);
          CacheUtil.putCacheHolidayData((List)oroHolidayParamlList.getResult());
        } 
      } 
    } catch (Exception e) {
      log.error("获取节假日缓存异常", e);
      e.printStackTrace();
    } 
    return CacheUtil.getCacheHolidayData();
  }
  
  public static boolean isIn(Date curDate, Date beginDate, Date endDate) {
    try {
      long beginMills = beginDate.getTime();
      long endMills = endDate.getTime();
      long thisMills = curDate.getTime();
      return (thisMills >= Math.min(beginMills, endMills) && thisMills <= Math.max(beginMills, endMills));
    } catch (Exception e) {
      e.printStackTrace();
      return true;
    } 
  }
  
  public ResultMap<AResultCode, Object> gantryDataCheck(String beginTime, String endTime) {
    ResultMap<AResultCode, Object> result = new ResultMap();
    log.info("ETC追偿历史数据新任务启动");
    exitTransNotUploadRecovery(beginTime, endTime);
    notReceivedSplitResultRecovery(beginTime, endTime);
    result.setCode(AResultCode.OK);
    return result;
  }
  
  public ResultMap<AResultCode, Object> gantryDataCheckNotUpload(String beginTime, String endTime) {
    ResultMap<AResultCode, Object> result = new ResultMap();
    log.info("ETC出口未上传追偿历史数据新任务启动");
    exitTransNotUploadRecovery(beginTime, endTime);
    result.setCode(AResultCode.OK);
    return result;
  }
  
  public ResultMap<AResultCode, Object> gantryDataCheckNotSplit(String beginTime, String endTime) {
    ResultMap<AResultCode, Object> result = new ResultMap();
    log.info("ETC未收到拆分结果追偿历史数据新任务启动");
    notReceivedSplitResultRecovery(beginTime, endTime);
    result.setCode(AResultCode.OK);
    return result;
  }
  
  public void exitTransNotUploadRecovery(String beginTime, String endTime) {
    try {
      log.info("ETC出口交易未上传追偿新任务启动");
      boolean isNext = false;
      boolean isHoliday = false;
      SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
      Date nowDate = new Date();
      Calendar calendar = Calendar.getInstance();
      calendar.setTime(nowDate);
      calendar.add(5, -11);
      String beginDate = sdf.format(calendar.getTime());
      Calendar nextcalendar = Calendar.getInstance();
      nextcalendar.setTime(sdf.parse(beginDate));
      nextcalendar.add(5, 1);
      String nextDate = sdf.format(nextcalendar.getTime());
      if (!StringUtil.isNull(beginTime) && !StringUtil.isNull(endTime)) {
        beginDate = beginTime;
        nextDate = endTime;
      } 
      List<HolidaysDto> daylist = getCacheHolidayData();
      SimpleDateFormat daysdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
      for (HolidaysDto bean : daylist) {
        isHoliday = isIn(sdf.parse(beginDate), daysdf.parse(bean.getBegindate()), daysdf.parse(bean.getEnddate()));
        boolean isNextHoliday = isIn(sdf.parse(nextDate), daysdf.parse(bean.getBegindate()), daysdf.parse(bean.getEnddate()));
        if (isNextHoliday)
          isNext = true; 
      } 
      if (StringUtil.isNull(beginTime) && StringUtil.isNull(endTime)) {
        TRecoveryJobBean initbean = new TRecoveryJobBean();
        initbean.setBeginDate(beginDate);
        initbean.setEndDate(nextDate);
        initbean.setStatus("0");
        this.etcRecoveryDataService.insertRecoveryJob(initbean);
      } 
      StringBuffer sql = new StringBuffer();
      sql.append("select tranpt_pid ,tranpt_vehicleid from  global_temp.bill_lifecycle_out_etc where tranpt_extime_1 >='" + beginDate + "' and tranpt_extime_1 <'" + nextDate + "' and tranpt_pid is not null\nand tranej_pid is null and  etctej_pid is null and etctpj_pid is null and fvex_pid is null and tranop_pid is null");
      log.info("---未上传 queryMongodbBySql---" + sql);
      JSONObject jsonObj = this.dataServiceDataApi.queryMongodbBySql("aa", sql.toString());
      JSONArray jsonArray = jsonObj.getJSONArray("jsonObjectresult");
      List<TprcNecuBean> tprcNeculist = new ArrayList<>();
      int jsonSize = jsonArray.size();
      log.info("---jsonSize---" + jsonSize);
      if (jsonSize > 0) {
        ExitQueryResultResponse exitRes = null;
        for (int i = 0; i < jsonSize; i++) {
          ExitTransQueryRequest exitReq = new ExitTransQueryRequest();
          String passId = jsonArray.getJSONObject(i).get("tranpt_pid").toString();
          String vehicleid = jsonArray.getJSONObject(i).get("tranpt_vehicleid").toString();
          exitReq.setPassId(passId);
          log.info("---入参---" + passId);
          try {
            exitRes = (ExitQueryResultResponse)LwClientHelper.binPostUrl((AbstractTypeRequest)exitReq);
          } catch (Exception e) {
            log.error("-出口交易数据查询服务异常-" + e);
            insertExpResultData(beginDate, nextDate, "ETC", passId, vehicleid, "出口交易数据查询服务异常");
          } 
          if (exitRes == null) {
            log.error("-出口交易数据查询服务查询为null-Req:{}", exitReq);
            insertExpResultData(beginDate, nextDate, "ETC", passId, vehicleid, "出口交易数据查询服务查询为null");
          } else {
            int exitStatus = exitRes.getExitStatus().intValue();
            List<TPasstuCheckBean> passtuCheckBeanList = this.etcRecoveryDataService.getPasstuCheckDataByPid(passId);
            for (TPasstuCheckBean bean : passtuCheckBeanList) {
              if (StringUtil.isNull(bean.getExTime()))
                continue; 
              SimpleDateFormat sdfTSplit = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
              Date exTime = sdfTSplit.parse(bean.getExTime());
              Date nowDate2 = sdfTSplit.parse(sdfTSplit.format(new Date()));
              log.info("出口时间:{}, 当前时间:{}", exTime, nowDate2);
              if (DateUtils.addDays(exTime, 15).before(nowDate2) || DateUtils.addDays(exTime, 10).after(nowDate2)) {
                log.info("发起追偿的时间不在发起省份计费终点时间后的10-15个自然日内不允许发起追偿");
                continue;
              } 
              if (isNext && 
                bean.getExTime().compareTo(beginDate + "T18:00:00") > 0 && !StringUtil.isNull(bean.getVehicleType()) && bean.getVehicleType().equals("1")) {
                int vehicleSeat = NumberUtil.isInteger(bean.getVehicleSeat()) ? Integer.parseInt(bean.getVehicleSeat()) : 7;
                if (vehicleSeat < 8) {
                  log.info("节假日通行开始前6小时一型客车不允许发起追偿");
                  continue;
                } 
              } 
              if (isHoliday && !StringUtil.isNull(bean.getVehicleType()) && bean.getVehicleType().equals("1")) {
                int vehicleSeat = NumberUtil.isInteger(bean.getVehicleSeat()) ? Integer.parseInt(bean.getVehicleSeat()) : 7;
                if (vehicleSeat < 8) {
                  log.info("节假日期间一型客车一型客车不允许发起追偿");
                  continue;
                } 
              } 
              if (!StringUtil.isNull(bean.getObuId()) && bean.getObuId().startsWith("0501")) {
                log.info("军队车辆、武警部队车辆不允许发起追偿");
                continue;
              } 
              if (vehicleid.contains("应急")) {
                log.info("车辆为悬挂应急救援专用号牌车辆不允许发起追偿");
                continue;
              } 
              if (!StringUtil.isNull(bean.getFee()) && Double.parseDouble(bean.getFee()) / 100.0D < 0.5D) {
                log.info("我省门架累计应收金额小于 0.5 元不允许发起追偿");
                continue;
              } 
              if (exitStatus == 3) {
                LastGantryQueryResponse gantryRes = null;
                if (!StringUtil.isNull(bean)) {
                  TprcNecuBean tprcNecuBean = new TprcNecuBean();
                  SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
                  SimpleDateFormat sdf2 = new SimpleDateFormat("yyyyMMddHHmmss");
                  tprcNecuBean.setId("430201-" + passId + "-" + sdf2.format(sdf1.parse(bean.getExTime())));
                  tprcNecuBean.setSerProvinceId("430201");
                  try {
                    LastGantryQueryRequest gantryReq = new LastGantryQueryRequest();
                    gantryReq.setPassId(passId);
                    gantryReq.setVehicleId(vehicleid);
                    gantryRes = (LastGantryQueryResponse)LwClientHelper.binPostUrl((AbstractTypeRequest)gantryReq);
                  } catch (Exception e) {
                    log.error("-necu-最后门架通行记录查询服务异常-", e);
                    insertExpResultData(beginDate, nextDate, "ETC", passId, vehicleid, "necu-最后门架通行记录查询服务异常");
                    continue;
                  } 
                  if (gantryRes == null) {
                    log.error("-necu-最后门架通行记录查询为null-PassId:{}, VehicleId:{}", passId, vehicleid);
                    insertExpResultData(beginDate, nextDate, "ETC", passId, vehicleid, "necu-最后门架通行记录查询为null");
                    continue;
                  } 
                  String gantryId = gantryRes.getGantryId();
                  String provinceId = gantryRes.getProvinceId();
                  if (!StringUtil.isNull(provinceId) && provinceId.equals("43")) {
                    TPasstuCheckBean gantryBean = this.etcRecoveryDataService.getGantryDataById(gantryId);
                    if (!StringUtil.isNull(gantryBean))
                      provinceId = gantryBean.getSerProvinceId(); 
                  } 
                  if (!StringUtil.isNull(provinceId) && !provinceId.equals("43")) {
                    tprcNecuBean.setLastTransProvinceId(provinceId + "0201");
                    tprcNecuBean.setLastTransGantryId(gantryId);
                    if (!StringUtil.isNull(bean.getOutFee()))
                      if (Integer.parseInt(bean.getOutFee()) > 0) {
                        tprcNecuBean.setFee(bean.getOutFee());
                      } else {
                        tprcNecuBean.setFee(bean.getFee());
                      }  
                    tprcNecuBean.setVehicleId(vehicleid);
                    tprcNecuBean.setVehicleType(bean.getVehicleType());
                    tprcNecuBean.setProvExTime(bean.getExTime());
                    tprcNecuBean.setPassId(passId);
                    tprcNecuBean.setEtcCardId(bean.getEtcCardId());
                    tprcNecuBean.setMediaType("1");
                    tprcNecuBean.setMediaNo(bean.getObuId());
                    tprcNecuBean.setEvidenceName(passId + ".txt");
                    tprcNecuBean.setEvidence(makeEvidenceData(passId));
                    tprcNecuBean.setVehicleSeat("5");
                    tprcNecuBean.setProvEnTime(bean.getEnTime());
                    tprcNecuBean.setProvEnPointId(bean.getEnPointId());
                    tprcNecuBean.setProvExPointId(bean.getExPointId());
                    tprcNecuBean.setProvEnTollStationName(bean.getEnTollStationName());
                    tprcNecuBean.setProvExTollStationName(bean.getExTollStationName());
                    List<BSIdBean> list = new ArrayList<>();
                    BSIdBean bsidBean = new BSIdBean();
                    bsidBean.setTollgrantryid(bean.getExPointId());
                    bsidBean.setTollstationid(bean.getExPointId());
                    bsidBean.setQuerydata(bean.getExTime());
                    list.add(bsidBean);
                    try {
                      ResultMap<AResultCode, List<CenterViewBean>> centerResult = this.basicDataServiceDataApi.getCenterById(list);
                      if ("0".equals(((AResultCode)centerResult.getCode()).getCode())) {
                        List<CenterViewBean> centerList = (List<CenterViewBean>)centerResult.getResult();
                        if (centerList.size() > 0) {
                          String sub_center_code = ((CenterViewBean)centerList.get(0)).getSectionownerid();
                          tprcNecuBean.setSubCenterCode(sub_center_code);
                          tprcNecuBean.setCurHandleCode(sub_center_code);
                        } 
                      } 
                    } catch (Exception e) {
                      log.info("查询分中心数据异常", e);
                      insertExpResultData(beginDate, nextDate, "ETC", passId, vehicleid, "查询分中心数据异常");
                      continue;
                    } 
                    TPasstuCheckBean necubean = this.etcRecoveryDataService.getTprcnecuDataByPassid(tprcNecuBean.getId());
                    if (!StringUtil.isNull(necubean) && necubean.getCount().equals("0"))
                      tprcNeculist.add(tprcNecuBean); 
                  } 
                } 
              } 
            } 
          } 
        } 
      } 
      log.info("SUCCESS");
      boolean necuTag = this.reconciliationService.insertTprcNecuList(tprcNeculist, "bill_lifecycle_out_etc");
      if (necuTag)
        this.etcRecoveryDataService.updateRecoveryStatus(beginDate); 
    } catch (Exception e) {
      log.error("ETC出口交易未上传追偿历史数据异常", e);
    } 
  }
  
  public void notReceivedSplitResultRecovery(String beginTime, String endTime) {
    try {
      log.info("ETC未收到拆分结果追偿历史数据新任务启动");
      SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
      Date nowDate = new Date();
      Calendar calendar = Calendar.getInstance();
      calendar.setTime(nowDate);
      calendar.add(5, -5);
      String beginDate = sdf.format(calendar.getTime());
      Calendar nextcalendar = Calendar.getInstance();
      nextcalendar.setTime(sdf.parse(beginDate));
      nextcalendar.add(5, 1);
      String nextDate = sdf.format(nextcalendar.getTime());
      if (!StringUtil.isNull(beginTime) && !StringUtil.isNull(endTime)) {
        beginDate = beginTime;
        nextDate = endTime;
      } 
      if (StringUtil.isNull(beginTime) && StringUtil.isNull(endTime)) {
        TRecoveryJobBean initbean = new TRecoveryJobBean();
        initbean.setBeginDate(beginDate);
        initbean.setEndDate(nextDate);
        initbean.setStatus("0");
        this.etcRecoveryDataService.insertRecoveryJob(initbean);
      } 
      StringBuffer sql = new StringBuffer();
      sql.append("select tranpt_pid ,tranpt_vehicleid from  global_temp.bill_lifecycle_out_etc where tranpt_extime_1 >='" + beginDate + "' and tranpt_extime_1 <'" + nextDate + "' and tranpt_pid is not null\nand tranej_pid is null and  etctej_pid is null and etctpj_pid is null and fvex_pid is null and tranop_pid is null");
      log.info("---未拆分 queryMongodbBySql---" + sql);
      JSONObject jsonObj = this.dataServiceDataApi.queryMongodbBySql("aa", sql.toString());
      JSONArray jsonArray = jsonObj.getJSONArray("jsonObjectresult");
      List<TprcNrscuBean> tprcNrsculist = new ArrayList<>();
      int jsonSize = jsonArray.size();
      log.info("---jsonSize---" + jsonSize);
      if (jsonSize > 0) {
        ExitQueryResultResponse exitRes = null;
        for (int i = 0; i < jsonSize; i++) {
          ExitTransQueryRequest exitReq = new ExitTransQueryRequest();
          String passId = jsonArray.getJSONObject(i).get("tranpt_pid").toString();
          String vehicleid = jsonArray.getJSONObject(i).get("tranpt_vehicleid").toString();
          exitReq.setPassId(passId);
          log.info("---入参---" + passId);
          try {
            exitRes = (ExitQueryResultResponse)LwClientHelper.binPostUrl((AbstractTypeRequest)exitReq);
          } catch (Exception e) {
            log.error("-出口交易数据查询服务异常-", e);
            insertExpResultData(beginDate, nextDate, "ETC", passId, vehicleid, "出口交易数据查询服务异常");
          } 
          int exitStatus = exitRes.getExitStatus().intValue();
          int accountStatus = (exitRes.getAccountStatus() != null) ? exitRes.getAccountStatus().intValue() : 0;
          int exitFeeType = (exitRes.getExitFeeType() != null) ? exitRes.getExitFeeType().intValue() : 0;
          int splitStatus = (exitRes.getSplitStatus() != null) ? exitRes.getSplitStatus().intValue() : 0;
          int accountResult = (exitRes.getResult() != null) ? exitRes.getResult().intValue() : 0;
          String tollProvinceId = (exitRes.getTollProvinceId() != null) ? exitRes.getTollProvinceId() : null;
          List<TPasstuCheckBean> passtuCheckBeanList = this.etcRecoveryDataService.getPasstuCheckDataByPid(passId);
          for (TPasstuCheckBean bean : passtuCheckBeanList) {
            String splitDate = exitRes.getSplitDate();
            SimpleDateFormat sdfTSplit = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
            SimpleDateFormat sdfSplit = new SimpleDateFormat("yyyy-MM-dd");
            if (StringUtil.isNull(splitDate) && !StringUtil.isNull(bean.getExTime()))
              splitDate = sdfSplit.format(sdfTSplit.parse(bean.getExTime())); 
            Date splitDate2 = sdfSplit.parse(splitDate);
            Date nowDate2 = sdfSplit.parse(sdfSplit.format(new Date()));
            log.info("拆分日期:{}, 当前日期:{}", splitDate2, nowDate2);
            if (DateUtils.addDays(splitDate2, 5).before(nowDate2)) {
              log.info("发起追偿的时间不在拆分日期起5个自然日内不允许发起追偿");
              continue;
            } 
            if (!StringUtil.isNull(bean.getFee()) && Double.parseDouble(bean.getFee()) / 100.0D < 0.5D) {
              log.info("我省门架累计应收金额小于 0.5 元不允许发起追偿");
              continue;
            } 
            if ((exitStatus == 2 && exitFeeType == 1) || exitStatus == 4) {
              boolean isTprcNescu = false;
              if (exitStatus == 4) {
                int count = this.etcRecoveryDataService.getCountEtcnsExitetcodByPassid(passId);
                if (count == 0)
                  isTprcNescu = true; 
              } else if (splitStatus == 1) {
                isTprcNescu = true;
              } else if (splitStatus == 0) {
                if (accountStatus == 3) {
                  if (accountResult == 1 || accountResult == 3 || accountResult == 10 || accountResult == 16) {
                    int count = this.etcRecoveryDataService.getCountEtcnsExitetcdrdByPassid(passId);
                    if (count == 0)
                      isTprcNescu = true; 
                  } else {
                    isTprcNescu = true;
                  } 
                } else {
                  isTprcNescu = true;
                } 
              } 
              if (isTprcNescu && 
                !StringUtil.isNull(bean)) {
                TprcNrscuBean tprcNrscuBean = new TprcNrscuBean();
                tprcNrscuBean.setId(bean.getId());
                tprcNrscuBean.setSerProvinceId("430201");
                if (!StringUtil.isNull(tollProvinceId) && !tollProvinceId.equals("430201")) {
                  tprcNrscuBean.setTollProvinceId(tollProvinceId);
                  tprcNrscuBean.setPassRecordId(bean.getId());
                  if (!StringUtil.isNull(bean.getOutFee()))
                    if (Integer.parseInt(bean.getOutFee()) > 0) {
                      tprcNrscuBean.setFee(bean.getOutFee());
                    } else {
                      tprcNrscuBean.setFee(bean.getFee());
                    }  
                  tprcNrscuBean.setVehicleId(bean.getVehicleId());
                  tprcNrscuBean.setVehicleType(bean.getVehicleType());
                  tprcNrscuBean.setPassId(passId);
                  tprcNrscuBean.setSplitDate(splitDate);
                  tprcNrscuBean.setProvEnTime(bean.getEnTime());
                  tprcNrscuBean.setProvExTime(bean.getExTime());
                  tprcNrscuBean.setEvidenceName(passId + ".txt");
                  tprcNrscuBean.setEvidence(makeEvidenceData(passId));
                  List<BSIdBean> list = new ArrayList<>();
                  BSIdBean bsidBean = new BSIdBean();
                  bsidBean.setTollgrantryid(bean.getExPointId());
                  bsidBean.setTollstationid(bean.getExPointId());
                  bsidBean.setQuerydata(bean.getExTime());
                  list.add(bsidBean);
                  try {
                    ResultMap<AResultCode, List<CenterViewBean>> centerResult = this.basicDataServiceDataApi.getCenterById(list);
                    if ("0".equals(((AResultCode)centerResult.getCode()).getCode())) {
                      List<CenterViewBean> centerList = (List<CenterViewBean>)centerResult.getResult();
                      if (centerList.size() > 0) {
                        String sub_center_code = ((CenterViewBean)centerList.get(0)).getSectionownerid();
                        tprcNrscuBean.setSubCenterCode(sub_center_code);
                        tprcNrscuBean.setCurHandleCode(sub_center_code);
                      } 
                    } 
                  } catch (Exception e) {
                    log.error("查询分中心数据异常", e);
                    insertExpResultData(beginDate, nextDate, "ETC", passId, vehicleid, "查询分中心数据异常");
                    continue;
                  } 
                  TPasstuCheckBean nrscubean = this.etcRecoveryDataService.getTprcnrscuDataByPassid(bean.getId());
                  if (!StringUtil.isNull(nrscubean) && nrscubean.getCount().equals("0"))
                    tprcNrsculist.add(tprcNrscuBean); 
                } 
              } 
            } 
          } 
        } 
      } 
      log.info("SUCCESS");
      boolean nrscuTag = this.reconciliationService.insertTprcNrscuList(tprcNrsculist, "bill_lifecycle_out_etc");
      if (nrscuTag)
        this.etcRecoveryDataService.updateRecoveryStatus(beginDate); 
    } catch (Exception e) {
      log.error("ETC未收到拆分结果追偿历史数据异常", e);
    } 
  }
  
  public void insertExpResultData(String beginDate, String endDate, String dataSource, String passId, String vehicleId, String info) {
    try {
      TRecoveryResultBean bean = new TRecoveryResultBean();
      bean.setBeginDate(beginDate);
      bean.setEndDate(endDate);
      bean.setDataSource(dataSource);
      bean.setPassId(passId);
      bean.setVehicleId(vehicleId);
      bean.setInfo(info);
      this.etcRecoveryDataService.insertExpResultData(bean);
      log.info("追偿异常数据入库成功");
    } catch (Exception e) {
      log.error("ETCRecoveryDataServiceImpl->insertExpResultData:", e);
      e.printStackTrace();
    } 
  }
  
  public ResultMap<AResultCode, Object> gantryDataCheckETC(String beginTime, String endTime) {
    ResultMap<AResultCode, Object> result = new ResultMap();
    try {
      log.info("ETC追偿历史数据新任务启动");
      SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
      Date nowDate = new Date();
      Calendar calendar = Calendar.getInstance();
      calendar.setTime(nowDate);
      calendar.add(5, -11);
      String beginDate = sdf.format(calendar.getTime());
      Calendar nextcalendar = Calendar.getInstance();
      nextcalendar.setTime(sdf.parse(beginDate));
      nextcalendar.add(5, 1);
      String nextDate = sdf.format(nextcalendar.getTime());
      if (!StringUtil.isNull(beginTime) && !StringUtil.isNull(endTime)) {
        beginDate = beginTime;
        nextDate = endTime;
      } else {
        List<HolidaysDto> daylist = getCacheHolidayData();
        SimpleDateFormat daysdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        for (HolidaysDto bean : daylist) {
          boolean isHoliday = isIn(sdf.parse(beginDate), daysdf.parse(bean.getBegindate()), daysdf.parse(bean.getEnddate()));
          if (isHoliday) {
            log.info("ETC节假日追偿过滤");
            TRecoveryJobBean tRecoveryJobBean = new TRecoveryJobBean();
            tRecoveryJobBean.setBeginDate(beginDate);
            tRecoveryJobBean.setEndDate(nextDate);
            tRecoveryJobBean.setStatus("2");
            this.etcRecoveryDataService.insertRecoveryJob(tRecoveryJobBean);
            result.setCode(AResultCode.OK);
            return result;
          } 
        } 
        TRecoveryJobBean initbean = new TRecoveryJobBean();
        initbean.setBeginDate(beginDate);
        initbean.setEndDate(nextDate);
        initbean.setStatus("0");
        this.etcRecoveryDataService.insertRecoveryJob(initbean);
      } 
      List<TprcNecuBean> tprcNeculist = new ArrayList<>();
      List<TprcNrscuBean> tprcNrsculist = new ArrayList<>();
      List<TRecoveryResultBean> recoveryList = this.trecoveryResultMapper.getRecovery4Etc();
      if (recoveryList.size() > 0) {
        ExitQueryResultResponse exitRes = null;
        for (int i = 0; i < recoveryList.size(); i++) {
          ExitTransQueryRequest exitReq = new ExitTransQueryRequest();
          String passId = ((TRecoveryResultBean)recoveryList.get(i)).getPassId();
          String vehicleid = ((TRecoveryResultBean)recoveryList.get(i)).getVehicleId();
          exitReq.setPassId(passId);
          log.info("---入参---" + passId);
          try {
            exitRes = (ExitQueryResultResponse)LwClientHelper.binPostUrl((AbstractTypeRequest)exitReq);
            log.info("---出口交易数据查询服务响应数据---" + JSONObject.toJSON(exitRes));
          } catch (Exception e) {
            log.info("-出口交易数据查询服务异常-" + e);
          } 
          int exitStatus = exitRes.getExitStatus().intValue();
          int accountStatus = (exitRes.getAccountStatus() != null) ? exitRes.getAccountStatus().intValue() : 0;
          int exitFeeType = (exitRes.getExitFeeType() != null) ? exitRes.getExitFeeType().intValue() : 0;
          int splitStatus = (exitRes.getSplitStatus() != null) ? exitRes.getSplitStatus().intValue() : 0;
          int accountResult = (exitRes.getResult() != null) ? exitRes.getResult().intValue() : 0;
          String tollProvinceId = (exitRes.getTollProvinceId() != null) ? exitRes.getTollProvinceId() : null;
          List<TPasstuCheckBean> passtuCheckBeanList = this.etcRecoveryDataService.getPasstuCheckDataByPid(passId);
          for (TPasstuCheckBean bean : passtuCheckBeanList) {
            if (exitStatus == 3) {
              LastGantryQueryResponse gantryRes = null;
              if (!StringUtil.isNull(bean)) {
                TprcNecuBean tprcNecuBean = new TprcNecuBean();
                SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
                SimpleDateFormat sdf2 = new SimpleDateFormat("yyyyMMddHHmmss");
                if (!StringUtil.isNull(bean.getExTime()))
                  tprcNecuBean.setId("430201-" + passId + "-" + sdf2.format(sdf1.parse(bean.getExTime()))); 
                tprcNecuBean.setSerProvinceId("430201");
                try {
                  LastGantryQueryRequest gantryReq = new LastGantryQueryRequest();
                  gantryReq.setPassId(passId);
                  gantryReq.setVehicleId(vehicleid);
                  gantryRes = (LastGantryQueryResponse)LwClientHelper.binPostUrl((AbstractTypeRequest)gantryReq);
                  log.info("---最后门架通行记录查询服务响应数据---" + JSONObject.toJSON(gantryRes));
                } catch (Exception e) {
                  log.info("-necu-最后门架通行记录查询服务异常-" + e);
                  continue;
                } 
                String gantryId = gantryRes.getGantryId();
                String provinceId = gantryRes.getProvinceId();
                if (!StringUtil.isNull(provinceId) && provinceId.equals("43")) {
                  TPasstuCheckBean gantryBean = this.etcRecoveryDataService.getGantryDataById(gantryId);
                  if (!StringUtil.isNull(gantryBean))
                    provinceId = gantryBean.getSerProvinceId(); 
                } 
                if (!StringUtil.isNull(provinceId) && !provinceId.equals("43")) {
                  tprcNecuBean.setLastTransProvinceId(provinceId + "0201");
                  tprcNecuBean.setLastTransGantryId(gantryId);
                  if (!StringUtil.isNull(bean.getOutFee()))
                    if (Integer.parseInt(bean.getOutFee()) > 0) {
                      tprcNecuBean.setFee(bean.getOutFee());
                    } else {
                      tprcNecuBean.setFee(bean.getFee());
                    }  
                  tprcNecuBean.setVehicleId(vehicleid);
                  tprcNecuBean.setVehicleType(bean.getVehicleType());
                  tprcNecuBean.setProvExTime(bean.getExTime());
                  tprcNecuBean.setPassId(passId);
                  tprcNecuBean.setEtcCardId(bean.getEtcCardId());
                  tprcNecuBean.setMediaType("1");
                  tprcNecuBean.setMediaNo(bean.getObuId());
                  tprcNecuBean.setEvidenceName(passId + ".txt");
                  tprcNecuBean.setEvidence(makeEvidenceData(passId));
                  tprcNecuBean.setVehicleSeat("5");
                  tprcNecuBean.setProvEnTime(bean.getEnTime());
                  tprcNecuBean.setProvEnPointId(bean.getEnPointId());
                  tprcNecuBean.setProvExPointId(bean.getExPointId());
                  tprcNecuBean.setProvEnTollStationName(bean.getEnTollStationName());
                  tprcNecuBean.setProvExTollStationName(bean.getExTollStationName());
                  List<BSIdBean> list = new ArrayList<>();
                  BSIdBean bsidBean = new BSIdBean();
                  bsidBean.setTollgrantryid(bean.getExPointId());
                  bsidBean.setTollstationid(bean.getExPointId());
                  bsidBean.setQuerydata(bean.getExTime());
                  list.add(bsidBean);
                  log.info("-----分中心入参-----" + JSONObject.toJSON(bsidBean));
                  try {
                    ResultMap<AResultCode, List<CenterViewBean>> centerResult = this.basicDataServiceDataApi.getCenterById(list);
                    log.info("--疑似分中心返回结果--" + JSONObject.toJSON(centerResult));
                    if ("0".equals(((AResultCode)centerResult.getCode()).getCode())) {
                      List<CenterViewBean> centerList = (List<CenterViewBean>)centerResult.getResult();
                      if (centerList.size() > 0) {
                        String sub_center_code = ((CenterViewBean)centerList.get(0)).getSectionownerid();
                        tprcNecuBean.setSubCenterCode(sub_center_code);
                        tprcNecuBean.setCurHandleCode(sub_center_code);
                      } 
                    } 
                  } catch (Exception e) {
                    log.info("查询分中心数据异常" + e);
                    continue;
                  } 
                  TPasstuCheckBean necubean = this.etcRecoveryDataService.getTprcnecuDataByPassid(tprcNecuBean.getId());
                  if (!StringUtil.isNull(necubean) && necubean.getCount().equals("0"))
                    tprcNeculist.add(tprcNecuBean); 
                } 
              } 
              continue;
            } 
            if ((exitStatus == 2 && exitFeeType == 1) || exitStatus == 4) {
              boolean isTprcNescu = false;
              if (exitStatus == 4) {
                int count = this.etcRecoveryDataService.getCountEtcnsExitetcodByPassid(passId);
                if (count == 0)
                  isTprcNescu = true; 
              } else if (splitStatus == 1) {
                isTprcNescu = true;
              } else if (splitStatus == 0) {
                if (accountStatus == 3) {
                  if (accountResult == 1 || accountResult == 3 || accountResult == 10 || accountResult == 16) {
                    int count = this.etcRecoveryDataService.getCountEtcnsExitetcdrdByPassid(passId);
                    if (count == 0)
                      isTprcNescu = true; 
                  } else {
                    isTprcNescu = true;
                  } 
                } else {
                  isTprcNescu = true;
                } 
              } 
              if (isTprcNescu && 
                !StringUtil.isNull(bean)) {
                TprcNrscuBean tprcNrscuBean = new TprcNrscuBean();
                tprcNrscuBean.setId(bean.getId());
                tprcNrscuBean.setSerProvinceId("430201");
                if (!StringUtil.isNull(tollProvinceId) && !tollProvinceId.equals("430201")) {
                  tprcNrscuBean.setTollProvinceId(tollProvinceId);
                  tprcNrscuBean.setPassRecordId(bean.getId());
                  if (!StringUtil.isNull(bean.getOutFee()))
                    if (Integer.parseInt(bean.getOutFee()) > 0) {
                      tprcNrscuBean.setFee(bean.getOutFee());
                    } else {
                      tprcNrscuBean.setFee(bean.getFee());
                    }  
                  tprcNrscuBean.setVehicleId(bean.getVehicleId());
                  tprcNrscuBean.setVehicleType(bean.getVehicleType());
                  tprcNrscuBean.setPassId(passId);
                  if (StringUtil.isNull(exitRes.getSplitDate()) && !StringUtil.isNull(bean.getExTime())) {
                    SimpleDateFormat sdfTSplit = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
                    SimpleDateFormat sdfSplit = new SimpleDateFormat("yyyy-MM-dd");
                    String splitDate = sdfSplit.format(sdfTSplit.parse(bean.getExTime()));
                    tprcNrscuBean.setSplitDate(splitDate);
                  } else {
                    tprcNrscuBean.setSplitDate(exitRes.getSplitDate());
                  } 
                  tprcNrscuBean.setProvEnTime(bean.getEnTime());
                  tprcNrscuBean.setProvExTime(bean.getExTime());
                  tprcNrscuBean.setEvidenceName(passId + ".txt");
                  tprcNrscuBean.setEvidence(makeEvidenceData(passId));
                  List<BSIdBean> list = new ArrayList<>();
                  BSIdBean bsidBean = new BSIdBean();
                  bsidBean.setTollgrantryid(bean.getExPointId());
                  bsidBean.setTollstationid(bean.getExPointId());
                  bsidBean.setQuerydata(bean.getExTime());
                  list.add(bsidBean);
                  log.info("-----分中心入参-----" + JSONObject.toJSON(bsidBean));
                  try {
                    ResultMap<AResultCode, List<CenterViewBean>> centerResult = this.basicDataServiceDataApi.getCenterById(list);
                    log.info("--疑似分中心返回结果--" + JSONObject.toJSON(centerResult));
                    if ("0".equals(((AResultCode)centerResult.getCode()).getCode())) {
                      List<CenterViewBean> centerList = (List<CenterViewBean>)centerResult.getResult();
                      if (centerList.size() > 0) {
                        String sub_center_code = ((CenterViewBean)centerList.get(0)).getSectionownerid();
                        tprcNrscuBean.setSubCenterCode(sub_center_code);
                        tprcNrscuBean.setCurHandleCode(sub_center_code);
                      } 
                    } 
                  } catch (Exception e) {
                    log.info("查询分中心数据异常" + e);
                    continue;
                  } 
                  TPasstuCheckBean nrscubean = this.etcRecoveryDataService.getTprcnrscuDataByPassid(bean.getId());
                  if (!StringUtil.isNull(nrscubean) && nrscubean.getCount().equals("0"))
                    tprcNrsculist.add(tprcNrscuBean); 
                } 
              } 
            } 
          } 
        } 
      } 
      boolean necuTag = this.reconciliationService.insertTprcNecuList(tprcNeculist, "bill_lifecycle_out_etc");
      boolean nrscuTag = this.reconciliationService.insertTprcNrscuList(tprcNrsculist, "bill_lifecycle_out_etc");
      if (necuTag && nrscuTag)
        this.etcRecoveryDataService.updateRecoveryStatus(beginDate); 
      result.setCode(AResultCode.OK);
    } catch (Exception e) {
      log.error("ETC追偿历史数据异常" + e);
      result.setCode(AResultCode.EXCEPTION);
    } 
    return result;
  }
  
  @Transactional(value = "defaultTx", rollbackFor = {Exception.class})
  @TargetDataSource(name = "first")
  public List<TPasstuCheckBean> getPasstuCheckDataByPid(String passId) {
    return this.tPasstuCheckMapper.getPasstuCheckDataByPid(passId);
  }
  
  @Transactional(value = "defaultTx", rollbackFor = {Exception.class})
  @TargetDataSource(name = "first")
  public TPasstuCheckBean getPasstuCheckFeeByPid(String passId) {
    TPasstuCheckBean bean = this.tPasstuCheckMapper.getPasstuCheckFeeByPid(passId);
    return bean;
  }
  
  @Transactional(value = "rongyuanTx", rollbackFor = {Exception.class})
  @TargetDataSource(name = "rongyuan")
  public int getCountEtcnsExitetcdrdByPassid(String passId) {
    return this.tPasstuCheckMapper.getCountEtcnsExitetcdrdByPassid(passId);
  }
  
  @Transactional(value = "rongyuanTx", rollbackFor = {Exception.class})
  @TargetDataSource(name = "rongyuan")
  public int getCountEtcnsExitetcodByPassid(String passId) {
    return this.tPasstuCheckMapper.getCountEtcnsExitetcodByPassid(passId);
  }
  
  @Transactional(value = "rongyuanTx", rollbackFor = {Exception.class})
  @TargetDataSource(name = "rongyuan")
  public TPasstuCheckBean getTprcnecuDataByPassid(String id) {
    return this.tPasstuCheckMapper.getTprcnecuDataByPassid(id);
  }
  
  @Transactional(value = "rongyuanTx", rollbackFor = {Exception.class})
  @TargetDataSource(name = "rongyuan")
  public TPasstuCheckBean getTprcnrscuDataByPassid(String id) {
    return this.tPasstuCheckMapper.getTprcnrscuDataByPassid(id);
  }
  
  @Transactional(value = "rongyuanTx", rollbackFor = {Exception.class})
  @TargetDataSource(name = "rongyuan")
  public List<TRecoveryJobBean> getRecoveryDate(String status) {
    return this.tPasstuCheckMapper.getRecoveryDate(status);
  }
  
  @Transactional(value = "rongyuanTx", rollbackFor = {Exception.class})
  @TargetDataSource(name = "rongyuan")
  public TRecoveryJobBean getRecoveryDataByDate(String beginDate, String endDate) {
    return this.tPasstuCheckMapper.getRecoveryDataByDate(beginDate, endDate);
  }
  
  @Transactional(value = "rongyuanTx", rollbackFor = {Exception.class})
  @TargetDataSource(name = "rongyuan")
  public void updateRecoveryStatus(String beginDate) {
    this.tPasstuCheckMapper.updateRecoveryStatus(beginDate);
  }
  
  @Transactional(value = "rongyuanTx", rollbackFor = {Exception.class})
  @TargetDataSource(name = "rongyuan")
  public void insertRecoveryJob(TRecoveryJobBean bean) {
    this.tPasstuCheckMapper.insertRecoveryJob(bean);
  }
  
  @Transactional(value = "thirdTx", rollbackFor = {Exception.class})
  @TargetDataSource(name = "third")
  public TPasstuCheckBean getGantryDataById(String gantryId) {
    return this.tPasstuCheckMapper.getGantryDataById(gantryId);
  }
  
  @Transactional(value = "rongyuanTx", rollbackFor = {Exception.class})
  @TargetDataSource(name = "rongyuan")
  public void insertExpResultData(TRecoveryResultBean bean) {
    this.trecoveryResultMapper.insertData(bean);
  }
  
  @Transactional(value = "rongyuanTx", rollbackFor = {Exception.class})
  @TargetDataSource(name = "rongyuan")
  public void test(String[] passId, String vehicleid, HttpServletResponse response) {
    try {
      List<ExitQueryResultResponse> list = new ArrayList<>();
      LastGantryQueryRequest gantryReq = new LastGantryQueryRequest();
      gantryReq.setPassId(passId[0]);
      gantryReq.setVehicleId(vehicleid);
      LastGantryQueryResponse gantryRes = (LastGantryQueryResponse)LwClientHelper.binPostUrl((AbstractTypeRequest)gantryReq);
      String gantryId = gantryRes.getGantryId();
      String provinceId = gantryRes.getProvinceId();
      log.info("--------------" + provinceId);
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
  
  public void exportExcelEtcDataMonitor(HttpServletResponse response, List<ExitQueryResultResponse> list) {
    try {
      String fileName = "";
      Map<Integer, List<ExitQueryResultResponse>> sheetMap = daData(list);
      HSSFWorkbook workbook = new HSSFWorkbook();
      for (Map.Entry<Integer, List<ExitQueryResultResponse>> entry : sheetMap.entrySet()) {
        Integer SheetKey = entry.getKey();
        HSSFSheet sheet = workbook.createSheet((fileName + SheetKey).toString());
        List<ExitQueryResultResponse> sheetRows = entry.getValue();
        HSSFRow row = sheet.createRow(0);
        HSSFCellStyle cellStyle = workbook.createCellStyle();
        String[] head = { "PASSID", "数据上传状态", "省中心优惠类型" };
        for (int k = 0; k < head.length; k++) {
          HSSFCell cell = row.createCell(k);
          cell.setCellValue(head[k]);
          cell.setCellStyle(cellStyle);
          sheet.setColumnWidth(k, 4000);
        } 
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        for (int a = 0; a < sheetRows.size(); a++) {
          row = sheet.createRow(a + 1);
          ExitQueryResultResponse bean = sheetRows.get(a);
          String[] bugTitle = new String[13];
          bugTitle[0] = bean.getPassId();
          bugTitle[1] = exitstatus(bean.getExitStatus().intValue());
          bugTitle[2] = (bean.getDiscountType() == null) ? null : discounttype(bean.getDiscountType().intValue());
          for (int b = 0; b < bugTitle.length; b++)
            row.createCell(b).setCellValue(bugTitle[b]); 
        } 
      } 
      String title = fileName;
      try {
        response.setContentType("application/vnd.ms-excel");
        ServletOutputStream servletOutputStream = response.getOutputStream();
        workbook.write((OutputStream)servletOutputStream);
        servletOutputStream.flush();
        servletOutputStream.close();
      } catch (UnsupportedEncodingException e) {
        log.error(e.getMessage(), e);
      } catch (IOException e) {
        log.error(e.getMessage(), e);
      } 
    } catch (Exception e) {
      log.error(e.getMessage(), e);
    } 
  }
  
  public String exitstatus(int exitstatus) {
    String existStatusName = null;
    switch (exitstatus) {
      case 1:
        existStatusName = "现金交易已上传";
        break;
      case 2:
        existStatusName = "ETC 交易已上传";
        break;
      case 3:
        existStatusName = "无出口数据";
        break;
      case 4:
        existStatusName = "ETC 交易上传逾期";
        break;
    } 
    return existStatusName;
  }
  
  public String discounttype(int discounttype) {
    String discountTypeName = null;
    switch (discounttype) {
      case 1:
        discountTypeName = "绿通";
        break;
      case 2:
        discountTypeName = "联合收割机";
        break;
      case 3:
        discountTypeName = "J1 类型集装箱";
        break;
      case 4:
        discountTypeName = "J2 类型集装箱";
        break;
      case 5:
        discountTypeName = "节假日";
        break;
    } 
    return discountTypeName;
  }
  
  public Map<Integer, List<ExitQueryResultResponse>> daData(List<ExitQueryResultResponse> list) {
    int count = list.size() / 60000;
    int yu = list.size() % 60000;
    Map<Integer, List<ExitQueryResultResponse>> map = new HashMap<>();
    for (int i = 0; i <= count; i++) {
      List<ExitQueryResultResponse> subList = new ArrayList<>();
      if (i == count) {
        subList = list.subList(i * 60000, 60000 * i + yu);
      } else {
        subList = list.subList(i * 60000, 60000 * (i + 1));
      } 
      map.put(Integer.valueOf(i), subList);
    } 
    return map;
  }
  
  @Transactional(value = "defaultTx", rollbackFor = {Exception.class})
  @TargetDataSource(name = "first")
  public String makeEvidenceData(String passId) {
    String xmlStr = null;
    try {
      List<TPasstuCheckBean> passBeanList = this.tPasstuCheckMapper.getPasstuCheckDataByPid(passId);
      if (passBeanList.size() > 0) {
        TPasstuCheckBean passBean = passBeanList.get(0);
        if (!StringUtil.isNull(passBean)) {
          List<TPasstuTransactionCheckBean> list = this.tPasstuTransactionCheckMapper.getPasstuTranCheckDataByPtid(passBean.getId());
          if (list.size() > 0)
            passBean.setTransaction(list); 
        } 
        ByteArrayOutputStream bOut = new ByteArrayOutputStream();
        bOut.write(JSON.toJSONString(passBean).getBytes());
        xmlStr = Base64.encode(bOut.toByteArray());
      } 
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return xmlStr;
  }
}
